data_bkp <- data

### utilities for maps ###
continent <- readOGR(paste(wd, "/standardization/utilities/continent/continent.shp", sep=""), verbose=F)
continent<- spTransform(continent, CRS("+proj=longlat +ellps=WGS84"))
d3 <- readOGR(paste(wd,"/standardization/utilities/bathymetry/200m_MED.shp", sep=""), layer="200m_MED", verbose =F)
d4 <- readOGR(paste(wd,"/standardization/utilities/bathymetry/500m_MED.shp", sep=""), layer="500m_MED", verbose =F)
d5 <- readOGR(paste(wd,"/standardization/utilities/bathymetry/800m_MED.shp", sep=""), layer="800m_MED", verbose =F)
map_range <- read.csv(paste(wd, "/standardization/utilities/GSAs_coordinates.csv", sep=""), sep=";")
map_range <- map_range[map_range$GSA == unique(data$GSA) & map_range$COUNTRY %in% as.character(unique(data$COUNTRY)) , ]

coord_range <- data.frame(matrix(NA, ncol=4, nrow=1))
colnames(coord_range) <- c("xmin", "xmax", "ymin", "ymax")
coord_range[1,1] <- min(map_range[,3])
coord_range[1,2] <- max(map_range[,4])
coord_range[1,3] <- min(map_range[,5])
coord_range[1,4] <- max(map_range[,6])
##########################


#if (ok_cancel_box("Model prediction for the month of June?")) cat(month_resp <- T) else cat(month_resp <- F)
std <- function(x) sd(x)/sqrt(length(x))

is.integer0 <- function(x)
{
  is.integer(x) && length(x) == 0L
}

# unique(data$vessel)
check_var <- 0
check_var <- grep("vessel", formula_best)
if (!is.integer0(check_var)){
   vessel_grid <- dlgInput(paste("Choose the vessel for the prediction grid: \n", paste(as.character(unique(data$vessel)), collapse = ", "), sep=""), default=as.character(unique(data$vessel[1])),Sys.info()[""])$res
   grid$vessel <- vessel_grid
   data$vessel <- vessel_grid
}

check_var <- 0
check_var <- grep("n_haul", formula_best)
if (!is.integer0(check_var)){
  n_haul_grid <- dlgInput(paste("Choose the reference number of hauls (n_haul) for the prediction grid: \n", paste(as.character(unique(data$n_haul)), collapse = ", "), sep=""), default=as.character(unique(data$n_haul[1])),Sys.info()[""])$res
  grid$n_haul <- n_haul_grid  # unique(data[data$year == max(data$year),"n_haul"])
  data$n_haul <- n_haul_grid
}



grid$stratum <- NA

strata_scheme <- read.table(paste(wd, "/standardization/utilities/strata.csv", sep=""), sep=";",header = T)
strata_scheme <- strata_scheme[strata_scheme$GSA == unique(merge_TATB$GSA) & strata_scheme$COUNTRY %in% as.character(country_analysis)[1], ]

n_strata <- length(strata_scheme$CODE)

if (analysis_stratum1){
  stratum_1 <- grid[grid$depth > strata_scheme[1,4] & grid$depth <= strata_scheme[1,5], ]
  stratum_1$stratum <- as.factor(1)
  grid[grid$depth > strata_scheme[1,4] & grid$depth <= strata_scheme[1,5], "stratum"] <- 1
}

if (analysis_stratum2){
  stratum_2 <- grid[grid$depth > strata_scheme[2,4] & grid$depth <= strata_scheme[2,5], ]
  stratum_2$stratum <- as.factor(2)
  grid[grid$depth > strata_scheme[2,4] & grid$depth <= strata_scheme[2,5], "stratum"] <- 2
}

if (analysis_stratum3){
  stratum_3 <- grid[grid$depth > strata_scheme[3,4] & grid$depth <= strata_scheme[3,5], ]
  stratum_3$stratum <- as.factor(3)
  grid[grid$depth > strata_scheme[3,4] & grid$depth <= strata_scheme[3,5], "stratum"] <- 3
}

if (analysis_stratum4){
  stratum_4 <- grid[grid$depth > strata_scheme[4,4] & grid$depth <= strata_scheme[4,5], ]
  stratum_4$stratum <- as.factor(4)
  grid[grid$depth > strata_scheme[4,4] & grid$depth <= strata_scheme[4,5], "stratum"] <- 4
}

if (analysis_stratum5){
  stratum_5 <- grid[grid$depth > strata_scheme[5,4] & grid$depth <= strata_scheme[5,5], ]
  stratum_5$stratum <- as.factor(5)
  grid[grid$depth > strata_scheme[5,4] & grid$depth <= strata_scheme[5,5], "stratum"] <- 5
}

if (analysis_stratum6){
  stratum_6 <- grid[grid$depth > strata_scheme[6,4] & grid$depth <= strata_scheme[6,5], ]
  stratum_6$stratum <- as.factor(6)
  grid[grid$depth > strata_scheme[6,4] & grid$depth <= strata_scheme[6,5], "stratum"] <- 6
  
}


    res_table  <- data.frame(year = sort(unique(data$year))) # data.frame(year=seq(1994, 2017,1))
    se_table   <- data.frame(year = sort(unique(data$year))) 
    # res_table2 <- data.frame(year = sort(unique(data$year)))
    # se_table2  <- data.frame(year = sort(unique(data$year)))
  

res_table$index_1 <- NA
res_table$index_2 <- NA
res_table$index_3 <- NA
res_table$index_4 <- NA
res_table$index_5 <- NA
res_table$index_6 <- NA

se_table$index_1 <- NA
se_table$index_2 <- NA
se_table$index_3 <- NA
se_table$index_4 <- NA
se_table$index_5 <- NA
se_table$index_6 <- NA

stratification <- read.table(paste(wd,"/standardization/utilities/stratification scheme.csv", sep=""), sep=";", header=T)

if (analysis_stratum1 == T){area_s1 <- sum(stratification[stratification$GSA == GSA & stratification$CODE==1 & stratification$COUNTRY %in% as.character(country_analysis),5])} else {area_s1 <- 0}
if (analysis_stratum2 == T){area_s2 <- sum(stratification[stratification$GSA == GSA & stratification$CODE==2 & stratification$COUNTRY %in% as.character(country_analysis),5])} else {area_s2 <- 0}
if (analysis_stratum3 == T){area_s3 <- sum(stratification[stratification$GSA == GSA & stratification$CODE==3 & stratification$COUNTRY %in% as.character(country_analysis),5])} else {area_s3 <- 0}
if (analysis_stratum4 == T){area_s4 <- sum(stratification[stratification$GSA == GSA & stratification$CODE==4 & stratification$COUNTRY %in% as.character(country_analysis),5])} else {area_s4 <- 0}
if (analysis_stratum5 == T){area_s5 <- sum(stratification[stratification$GSA == GSA & stratification$CODE==5 & stratification$COUNTRY %in% as.character(country_analysis),5])} else {area_s5 <- 0}
if (analysis_stratum6 == T){area_s6 <- sum(stratification[stratification$GSA == GSA & stratification$CODE==6 & stratification$COUNTRY %in% as.character(country_analysis),5])} else {area_s6 <- 0}

peso_s1 <- area_s1/sum(area_s1,area_s2,area_s3,area_s4,area_s5,area_s6)
peso_s2 <- area_s2/sum(area_s1,area_s2,area_s3,area_s4,area_s5,area_s6)
peso_s3 <- area_s3/sum(area_s1,area_s2,area_s3,area_s4,area_s5,area_s6)
peso_s4 <- area_s4/sum(area_s1,area_s2,area_s3,area_s4,area_s5,area_s6)
peso_s5 <- area_s5/sum(area_s1,area_s2,area_s3,area_s4,area_s5,area_s6)
peso_s6 <- area_s6/sum(area_s1,area_s2,area_s3,area_s4,area_s5,area_s6)

cat("\f")
map_response <- check_country <-  menu(c("Yes", "No"), title=  paste("Would you like to save the prediction maps for each year?",sep="")  )

i=1
for(i in 1:length(res_table[,1])){
  
   month <- month_st

  # vessel_grid <- unique(data[data$year ==res_table[i,1], "vessel"])
  
  # identity
  if (transformation =="1" & linkfun=="identity") { 
    t <- "identity"
    source(paste(wd,"/standardization/1-identity.R", sep=""), encoding = 'UTF-8')
  }
  
  # sqrt transformation
   if (transformation =="2" & linkfun=="identity") { 
     t <- "sqrt"
     source(paste(wd,"/standardization/2-sqrt.R", sep=""), encoding = 'UTF-8')
   }
   
  
  
   # log transformation or link
   # if (transformation =="3" | linkfun=="log") {
   #   t <- "log"
   #   source(paste(wd,"/standardization/3-log___SD.R", sep=""), encoding = 'UTF-8')
   # }
   if (transformation =="3") {
     t <- "log"
     source(paste(wd,"/standardization/3-log.R", sep=""), encoding = 'UTF-8')
   }
   if (linkfun=="log") {
     t <- "log"
     source(paste(wd,"/standardization/3-log_link.R", sep=""), encoding = 'UTF-8')
   }
  
  # inverse transformation
  if (transformation =="4" | linkfun =="inverse") { 
    t <- "inverse"
    source(paste(wd,"/standardization/4-inverse.R", sep=""), encoding = 'UTF-8')
  }
  
  # quadratic transformation
  if (transformation =="5" & linkfun =="identity") { 
    t <- "quadratic"
    source(paste(wd,"/standardization/5-quadratic.R", sep=""), encoding = 'UTF-8')
  }
  
  if(map_response==1){
      source(paste(wd,"/standardization/annual_maps.R", sep=""), encoding = 'UTF-8')
   }
   
   sum_res <- c(res_table[i,2]*peso_s1,res_table[i,3]*peso_s2,res_table[i,4]*peso_s3,res_table[i,5]*peso_s4,res_table[i,6]*peso_s5,res_table[i,7]*peso_s6)
  res_table[i, 8]<- sum(sum_res[!is.na(sum_res)])
   
  sum_se <- c(se_table[i,2],se_table[i,3],se_table[i,4],se_table[i,5],se_table[i,6],se_table[i,7])
  se_table[i, 8]<- sqrt(sum(sum_se[!is.na(sum_se)]))
}

month_list <- data.frame(matrix(NA, nrow=12,ncol=2))
colnames(month_list) <- c("month_num", "month_name")
month_list[,1] <- c(1,2,3,4,5,6,7,8,9,10,11,12)
month_list[,2] <- c("January","February", "March","April","May","June","July","August", "September","October","November", "December")

colnames(res_table) <- c("year", "stratum 1","stratum 2", "stratum 3", "stratum 4", "stratum 5", "stratum 6", "Indices")
colnames(se_table) <- c("year", "stratum 1","stratum 2", "stratum 3", "stratum 4", "stratum 5", "stratum 6", "sd")

dats_bkp_2 <- data
    source(paste(wd,"/standardization/Indices_timeseries.R", sep=""), encoding = 'UTF-8')
data <- dats_bkp_2

files <- list.files(paste(wd,"/output_GAM/", sep=""))
names <- data.frame(names <- NULL)
names [1,1] <- paste(sspp,"_GSA",GSA,"_(",dependent,")_",depth_range[1],"-",depth_range[2], " m_Timeseries.csv", sep="")
names [2,1] <- paste(sspp,"_GSA",GSA,"_(",dependent,")-Random_Stratified_Sampling_",depth_range[1],"-",depth_range[2], " m_Timeseries.csv", sep="")
names [3,1] <- paste(sspp,"_GSA",GSA,"_(",dependent,")-Random_Penalized_Sampling_",depth_range[1],"-",depth_range[2], " m_Timeseries.csv", sep="")
colnames(names) <- "names"

r_file <- data.frame(matrix(NA,ncol=3,nrow=1))
if (names [1,1] %in% files) {r_file[1,1] = 1} else {r_file[1,1] = 0}
if (names [2,1] %in% files) {r_file[1,2] = 1} else {r_file[1,2] = 0}
if (names [3,1] %in% files) {r_file[1,3] = 1} else {r_file[1,3] = 0}

sel_file <- which(r_file==1)

timeseries <- read.table(paste(wd,"/output_GAM/",names[sel_file,1], sep=""), sep=";", header=T)
GRID_PREDICTIONS <- data.frame(year = res_table[,"year"], response = res_table[,"Indices"], sd =se_table[,"sd"])
colnames(GRID_PREDICTIONS)[2] <- dependent


source(paste(wd,"/standardization/Index_Prediction_haul.R", sep=""), encoding = 'UTF-8')
HAUL_PREDICTION <- HAUL_PREDICTION



if (dependent =="biomass" | dependent =="2"){
  dep_text <- expression(paste("biomass (", kg/km^2, ")", sep=""))
} else { dep_text <- expression(paste("abundance (", n/km^2, ")", sep="")) }

#############################
##Plot of grid precictions ##
#############################
main <- paste(sspp,"_GSA",GSA,"_(",dependent,")_",family,"_",tranf_type,"_",linkfun,"_",depth_range[1],"-",depth_range[2],"_",month_list[month_list$month_num==month_st,2],"_GRID", sep="")
main.lab <- paste(sspp,"_GSA",GSA,"_(",dependent,")_",family,"_",tranf_type,"_",linkfun,"_",depth_range[1],"-",depth_range[2],"_",month_list[month_list$month_num==month_st,2],"_GRID", sep="")
max_index <- max(( max(GRID_PREDICTIONS[!is.na(GRID_PREDICTIONS[,2]),2])+ max(GRID_PREDICTIONS[!is.na(GRID_PREDICTIONS$sd), "sd"])  ), (max(timeseries[!is.na(timeseries[,2]),2]) + max(timeseries[!is.na(timeseries$sd),"sd"]) )) 

df_grid <- data.frame(year = GRID_PREDICTIONS[,"year"], 
                      pred = GRID_PREDICTIONS[,2], 
                      sd =GRID_PREDICTIONS[,"sd"] , 
                      time_series = timeseries[,2], 
                      sd_ts =timeseries[,"sd"])
colnames(df_grid)[2] <- dependent
write.table(df_grid, paste(wd,"/output_GAM/",main,"_prediction.csv", sep=""), sep=";", row.names = F)

par(mfrow=c(1,1),oma=c(1,1,1,1), mar=c(6,6,3,2), mgp=c(4, 2, 0))
plot(GRID_PREDICTIONS[,1], GRID_PREDICTIONS[,2], type="b", pch=16, xlab="year", ylim=c(0,max_index*1.2), ylab=dep_text, main=main.lab)
lines(GRID_PREDICTIONS[,1], (GRID_PREDICTIONS[,2]-GRID_PREDICTIONS[,"sd"]), type="l",lty=2, col="black" )
lines(GRID_PREDICTIONS[,1], (GRID_PREDICTIONS[,2]+GRID_PREDICTIONS[,"sd"]), type="l",lty=2, col="black" )
lines(timeseries[,1],  timeseries[,2], type="b", col="red")
lines(timeseries[,1], (timeseries[,2]-timeseries[,"sd"]), type="l",lty=2, col="red" )
lines(timeseries[,1], (timeseries[,2]+timeseries[,"sd"]), type="l",lty=2, col="red" )
legend("topright", c("prediction", "time series","+/- SD", "+/- SD"), lty=c(1,1,2,2), pch=c(16, 1,NA,NA), col=c("black","red","black","red"))

tiff(paste(wd,"/output_GAM/",main,"_prediction.tiff",sep=""), res = 300, width = 8, height = 7, units = 'in', compression = 'lzw', pointsize = 1/300)
par(mfrow=c(1,1),oma=c(1,1,1,1), mgp=c(2, 1,0)) 
plot(GRID_PREDICTIONS[,1], GRID_PREDICTIONS[,2], type="b", pch=16, xlab="year", ylim=c(0,max_index*1.2), ylab=dep_text, main=main.lab) 
lines(GRID_PREDICTIONS[,1], (GRID_PREDICTIONS[,2]-GRID_PREDICTIONS[,"sd"]), type="l",lty=2, col="black" )
lines(GRID_PREDICTIONS[,1], (GRID_PREDICTIONS[,2]+GRID_PREDICTIONS[,"sd"]), type="l",lty=2, col="black" )
lines(timeseries[,1],  timeseries[,2], type="b", col="red")
lines(timeseries[,1], (timeseries[,2]-timeseries[,"sd"]), type="l",lty=2, col="red" )
lines(timeseries[,1], (timeseries[,2]+timeseries[,"sd"]), type="l",lty=2, col="red" )
legend("topright", c("prediction", "time series","+/- SD", "+/- SD"), lty=c(1,1,2,2), pch=c(16, 1,NA,NA), col=c("black","red","black","red"))
dev.off()

##############################
##Plot of hauls precictions ##
##############################
main <- paste(sspp,"_GSA",GSA,"_(",dependent,")_",family,"_",tranf_type,"_",linkfun,"_",depth_range[1],"-",depth_range[2],"_",month_list[month_list$month_num==month_st,2],"_HAULS", sep="")
main.lab <- paste(sspp,"_GSA",GSA,"_(",dependent,")_",family,"_",tranf_type,"_",linkfun,"_",depth_range[1],"-",depth_range[2],"_",month_list[month_list$month_num==month_st,2],"_HAULS", sep="")
max_index <- max(( max(HAUL_PREDICTION[!is.na(HAUL_PREDICTION[,2]),2])+ max(HAUL_PREDICTION[!is.na(HAUL_PREDICTION$sd), "sd"])  ), (max(timeseries[!is.na(timeseries[,2]),2]) + max(timeseries[!is.na(timeseries$sd),"sd"]) )) 

df_grid <- data.frame(year = HAUL_PREDICTION[,"year"], 
                      pred = HAUL_PREDICTION[,2], 
                      sd =HAUL_PREDICTION[,"sd"] , 
                      time_series = timeseries[,2], 
                      sd_ts =timeseries[,"sd"])
colnames(df_grid)[2] <- dependent
write.table(df_grid, paste(wd,"/output_GAM/",main,"_prediction.csv", sep=""), sep=";", row.names = F)

par(mfrow=c(1,1),oma=c(1,1,1,1), mar=c(6,6,3,2), mgp=c(4, 2, 0))
plot(HAUL_PREDICTION[,1], HAUL_PREDICTION[,2], type="b", pch=16, xlab="year", ylim=c(0,max_index*1.2), ylab=dep_text, main=main.lab)
lines(HAUL_PREDICTION[,1], (HAUL_PREDICTION[,2]-HAUL_PREDICTION[,"sd"]), type="l",lty=2, col="black" )
lines(HAUL_PREDICTION[,1], (HAUL_PREDICTION[,2]+HAUL_PREDICTION[,"sd"]), type="l",lty=2, col="black" )
lines(timeseries[,1],  timeseries[,2], type="b", col="red")
lines(timeseries[,1], (timeseries[,2]-timeseries[,"sd"]), type="l",lty=2, col="red" )
lines(timeseries[,1], (timeseries[,2]+timeseries[,"sd"]), type="l",lty=2, col="red" )
legend("topright", c("prediction", "time series","+/- SD", "+/- SD"), lty=c(1,1,2,2), pch=c(16, 1,NA,NA), col=c("black","red","black","red"))

tiff(paste(wd,"/output_GAM/",main,"_prediction.tiff",sep=""), res = 300, width = 8, height = 7, units = 'in', compression = 'lzw', pointsize = 1/300)
par(mfrow=c(1,1),oma=c(1,1,1,1), mgp=c(2, 1,0)) 
plot(HAUL_PREDICTION[,1], HAUL_PREDICTION[,2], type="b", pch=16, xlab="year", ylim=c(0,max_index*1.2), ylab=dep_text, main=main.lab) 
lines(HAUL_PREDICTION[,1], (HAUL_PREDICTION[,2]-HAUL_PREDICTION[,"sd"]), type="l",lty=2, col="black" )
lines(HAUL_PREDICTION[,1], (HAUL_PREDICTION[,2]+HAUL_PREDICTION[,"sd"]), type="l",lty=2, col="black" )
lines(timeseries[,1],  timeseries[,2], type="b", col="red")
lines(timeseries[,1], (timeseries[,2]-timeseries[,"sd"]), type="l",lty=2, col="red" )
lines(timeseries[,1], (timeseries[,2]+timeseries[,"sd"]), type="l",lty=2, col="red" )
legend("topright", c("prediction", "time series","+/- SD", "+/- SD"), lty=c(1,1,2,2), pch=c(16, 1,NA,NA), col=c("black","red","black","red"))
dev.off()

#--------------------------------------------------------------
# summary of the model
#--------------------------------------------------------------
main_sum <- paste(sspp,"_GSA",GSA,"_(",dependent,")_",family,"_",tranf_type,"_",linkfun,"_","_",depth_range[1],"-",depth_range[2],"_", sep="")

cat("***************",file=paste(wd,"/output_GAM/",main_sum,"_summary.txt", sep=""),sep="\n",append=F)
cat(paste("family: ", family),file=paste(wd,"/output_GAM/",main_sum,"_summary.txt", sep=""),sep="\n",append=TRUE)
cat(paste("link  : ", linkfun),file=paste(wd,"/output_GAM/",main_sum,"_summary.txt", sep=""),sep="\n",append=TRUE)
cat(paste("transformation: ", tranf_type),file=paste(wd,"/output_GAM/",main_sum,"_summary.txt", sep=""),sep="\n",append=TRUE)
cat("***************",file=paste(wd,"/output_GAM/",main_sum,"_summary.txt", sep=""),sep="\n",append=TRUE)
cat("-- Summary of the model --",file=paste(wd,"/output_GAM/",main_sum,"_summary.txt", sep=""),sep="\n",append=TRUE)
text1 <- print(summary(mod))
out1 <- capture.output(text1)
cat(out1,file=paste(wd,"/output_GAM/",main_sum,"_summary.txt", sep=""),sep="\n",append=TRUE)

data <- data_bkp

