merge_TATB <- data
  
  if (is.na(sspp)) {
    GENERE <- as.character(unique(merge_TATB$GENUS)[unique(merge_TATB$GENUS) != -1])
    SPECIE <- as.character(unique(merge_TATB$SPECIES)[unique(merge_TATB$SPECIES) != -1])
    sspp <- paste(GENERE,SPECIE, sep="")
    species <- sspp
  }
  
  strata_scheme <- read.table(paste(wd, "/standardization/utilities/strata.csv", sep=""), sep=";",header = T)
  strata_scheme <- strata_scheme[strata_scheme$GSA == unique(merge_TATB$GSA) & strata_scheme$COUNTRY %in% as.character(unique(merge_TATB$COUNTRY))[1], ]
  
    
    depth <- data.frame(matrix(NA,ncol=4, nrow=length(strata_scheme$CODE)))
    colnames(depth) <- c("strata", "min", "max", "bul")
    depth$strata <- strata_scheme$CODE # c(1,2,3,4,5)
    depth$min <-strata_scheme$MIN_DEPTH  # c(10,50,100,200,500)
    depth$max <-strata_scheme$MAX_DEPTH  # c(50,100,200,500,800)
    
    
    # depth_range <- data.frame(depth_res[[2]])
    # depth_range <- as.numeric(as.character(depth_range[,1]))
    if (depth_range[2] != 800) {depth_range[2] <- depth_range[2]}
    merge_TATB <-  merge_TATB[merge_TATB$depth>=depth_range[1] & merge_TATB$depth<depth_range[2],]
    strata_range <- seq(which(depth[,"min"]==depth_range[1]),which(depth[,"max"]==depth_range[2]),1)
    depth[depth$strata %in% strata_range, "bul"] <- TRUE
    depth[!(depth$strata %in% strata_range), "bul"] <- FALSE
    
    analysis_stratum1 <- NA
    analysis_stratum2 <- NA
    analysis_stratum3 <- NA
    analysis_stratum4 <- NA
    analysis_stratum5 <- NA
    analysis_stratum6 <- NA
    
    analysis_stratum1 <- depth[1,4]
    analysis_stratum2 <- depth[2,4]
    analysis_stratum3 <- depth[3,4]
    analysis_stratum4 <- depth[4,4]
    analysis_stratum5 <- depth[5,4]
    analysis_stratum6 <- depth[6,4]
    
    if (is.na(analysis_stratum1)){depth[1,4]<- FALSE; analysis_stratum1 <- FALSE}
    if (is.na(analysis_stratum2)){depth[2,4]<- FALSE; analysis_stratum2 <- FALSE}
    if (is.na(analysis_stratum3)){depth[3,4]<- FALSE; analysis_stratum3 <- FALSE}
    if (is.na(analysis_stratum4)){depth[4,4]<- FALSE; analysis_stratum4 <- FALSE}
    if (is.na(analysis_stratum5)){depth[5,4]<- FALSE; analysis_stratum5 <- FALSE}
    if (is.na(analysis_stratum6)){depth[6,4]<- FALSE; analysis_stratum6 <- FALSE}
    
    #------------------------------------------
    
    
    ddd <- merge_TATB
    year_range <- data.frame(year = sort(unique(merge_TATB$year)))
    
    res_table_haul  <- data.frame(year = sort(unique(ddd$year))) # data.frame(year=seq(1994, 2017,1))
    se_table_haul   <- data.frame(year = sort(unique(ddd$year))) 
    
    res_table_haul$index_1 <- NA
    res_table_haul$index_2 <- NA
    res_table_haul$index_3 <- NA
    res_table_haul$index_4 <- NA
    res_table_haul$index_5 <- NA
    res_table_haul$index_6 <- NA
    
    se_table_haul$index_1 <- NA
    se_table_haul$index_2 <- NA
    se_table_haul$index_3 <- NA
    se_table_haul$index_4 <- NA
    se_table_haul$index_5 <- NA
    se_table_haul$index_6 <- NA
    
    sem_table <- data.frame(year=sort(unique(data$year)))
    sem_table$sd <- NA
    sem_table$n <- 0
    sem_table$sem <- NA
    
      if (analysis_stratum1 == TRUE){area_s1 <- sum(stratification[stratification$GSA == GSA & stratification$CODE==1,5])} else {area_s1 <- 0}
      if (analysis_stratum2 == TRUE){area_s2 <- sum(stratification[stratification$GSA == GSA & stratification$CODE==2,5])} else {area_s2 <- 0}
      if (analysis_stratum3 == TRUE){area_s3 <- sum(stratification[stratification$GSA == GSA & stratification$CODE==3,5])} else {area_s3 <- 0}
      if (analysis_stratum4 == TRUE){area_s4 <- sum(stratification[stratification$GSA == GSA & stratification$CODE==4,5])} else {area_s4 <- 0}
      if (analysis_stratum5 == TRUE){area_s5 <- sum(stratification[stratification$GSA == GSA & stratification$CODE==5,5])} else {area_s5 <- 0}
      if (analysis_stratum6 == TRUE){area_s6 <- sum(stratification[stratification$GSA == GSA & stratification$CODE==6,5])} else {area_s6 <- 0}
    
    peso_s1 <- area_s1/sum(area_s1,area_s2,area_s3,area_s4,area_s5,area_s6)
    peso_s2 <- area_s2/sum(area_s1,area_s2,area_s3,area_s4,area_s5,area_s6)
    peso_s3 <- area_s3/sum(area_s1,area_s2,area_s3,area_s4,area_s5,area_s6)
    peso_s4 <- area_s4/sum(area_s1,area_s2,area_s3,area_s4,area_s5,area_s6)
    peso_s5 <- area_s5/sum(area_s1,area_s2,area_s3,area_s4,area_s5,area_s6)
    peso_s6 <- area_s6/sum(area_s1,area_s2,area_s3,area_s4,area_s5,area_s6)
    
    
    # check_var <- 0
    # check_var <- grep("vessel", formula_best)
    # if (!is.integer0(check_var)){
    #   vessel_grid <- dlgInput(paste("Choose the vessel for the prediction grid: \n", paste(as.character(unique(data$vessel)), collapse = ", "), sep=""), default=as.character(unique(data$vessel[1])),Sys.info()[""])$res
    #   ddd$vessel <- vessel_grid
    # }
    # 
    # check_var <- 0
    # check_var <- grep("n_haul", formula_best)
    # if (!is.integer0(check_var)){
    #   n_haul_grid <- dlgInput(paste("Choose the reference number of hauls (n_haul) for the prediction grid: \n", paste(as.character(unique(data$n_haul)), collapse = ", "), sep=""), default=as.character(unique(data$n_haul[1])),Sys.info()[""])$res
    #   ddd$n_haul <- n_haul_grid   # unique(data[data$year == max(data$year),"n_haul"])
    # }
    # 
    
    
    i=1

  for(i in 1:length(res_table_haul[,1])) {
        
        data2 <- ddd[ddd$year == res_table_haul[i,1] , ]
        
        
        
        if (analysis_stratum1 == TRUE) {
          stratum_1 <- data2[data2$depth >= depth[1,2] & data2$depth < depth[1,3], ]
          if(nrow(stratum_1)>0){
            sem_table[i, "n"] <- nrow(stratum_1) + sem_table[i, "n"]
          }
          }
        if (analysis_stratum2 == TRUE) {
          stratum_2 <- data2[data2$depth >= depth[2,2] & data2$depth < depth[2,3], ]
          if(nrow(stratum_2)>0){
            sem_table[i, "n"] <- nrow(stratum_2) + sem_table[i, "n"]
          }
          }
        if (analysis_stratum3 == TRUE) {
          stratum_3 <- data2[data2$depth >= depth[3,2] & data2$depth < depth[3,3], ]
          if(nrow(stratum_3)>0){
            sem_table[i, "n"] <- nrow(stratum_3) + sem_table[i, "n"]
          }
          }
        if (analysis_stratum4 == TRUE) {
          stratum_4 <- data2[data2$depth >= depth[4,2] & data2$depth < depth[4,3], ]
          if(nrow(stratum_4)>0){
            sem_table[i, "n"] <- nrow(stratum_4) + sem_table[i, "n"]
          }
        }
        if (analysis_stratum5 == TRUE) {
          stratum_5 <- data2[data2$depth >= depth[5,2] & data2$depth < depth[5,3], ]
          if(nrow(stratum_5)>0){
            sem_table[i, "n"] <- nrow(stratum_5) + sem_table[i, "n"]
          }
          }
        if (analysis_stratum6 == TRUE) {
          stratum_6 <- data2[data2$depth >= depth[6,2] & data2$depth < depth[6,3], ]
          if(nrow(stratum_6)>0){
            sem_table[i, "n"] <- nrow(stratum_6) + sem_table[i, "n"]
          }
          }
        
        
        # identity
        if (transformation ==1 & linkfun=="identity") { 
          t <- "identity"
          source(paste(wd, "/standardization/1-identity_cale.R", sep=""), encoding = 'UTF-8')
        }
        
        # sqrt transformation
        if (transformation =="2" & linkfun=="identity") { 
          t <- "sqrt"
          source(paste(wd,"/standardization/2-sqrt_cale.R", sep=""), encoding = 'UTF-8')
        }
        
        # log transformation or link

        if (transformation =="3") {
          t <- "log"
          source(paste(wd,"/standardization/3-log_cale.R", sep=""), encoding = 'UTF-8')
        }
        
        if (linkfun=="log") {
          t <- "log"
          source(paste(wd,"/standardization/3-log_cale_link.R", sep=""), encoding = 'UTF-8')
        }
        
        # inverse transformation
        if (transformation =="4" | linkfun =="inverse") { 
          t <- "inverse"
          source(paste(wd,"/standardization/4-inverse_cale.R", sep=""), encoding = 'UTF-8')
          # source(paste(path, "/script/Index_estimation.R", sep=""), encoding = 'UTF-8')
        }
        
        # quadratic transformation
        if (transformation =="5" & linkfun =="identity") { 
          t <- "quadratic"
          source(paste(wd,"/standardization/5-quadratic_cale.R", sep=""), encoding = 'UTF-8')
        }
        
        # sss <- rbind( stratum_4, stratum_5)
        # write.table(sss, paste(wd, "/output_GAM/",YEAR,"_",sspp,"_(",dependent,")_",depth_range[1],"-",depth_range[2],"_prediction_hauls.csv", sep = ""), sep=";", row.names=FALSE)
        
        
        sum_res <- c(res_table_haul[i,2]*peso_s1,res_table_haul[i,3]*peso_s2,res_table_haul[i,4]*peso_s3,res_table_haul[i,5]*peso_s4,res_table_haul[i,6]*peso_s5,res_table_haul[i,7]*peso_s6)
        res_table_haul[i, 8]<- sum(sum_res[!is.na(sum_res)]) #/sum(area_s1,area_s2,area_s3,area_s4,area_s5, area_s6)
        
        sum_se <- c(se_table_haul[i,2],se_table_haul[i,3],se_table_haul[i,4],se_table_haul[i,5],se_table_haul[i,6],se_table_haul[i,7])
        se_table_haul[i, 8]<- sqrt(sum(sum_se[!is.na(sum_se)])) #/sum(area_s1,area_s2,area_s3,area_s4,area_s5,area_s6)
        
        sem_table$sd <-  se_table_haul[i, 8]
        
        if (!is.na(sem_table[i, "sd"]) & !is.na(sem_table[i, "n"]) & sem_table[i, "n"]>0 ){
          sem_table$sem[i] <- sem_table[i, "sd"]/ sqrt(sem_table[i, "n"])
        } else { sem_table$sem[i] <- NA }
        
      }

    HAUL_PREDICTION <- data.frame(year = res_table_haul[,1], response = res_table_haul[,8], sd= se_table_haul[, 8], se=sem_table$sem)
    colnames(HAUL_PREDICTION)[2] <- dependent
    