cols_explore <- c("year","month","houl","hour","X","Y","depth")

data2 <- data[  ,colnames(data) %in% cols_explore]
data2 <- cbind(data[,"response"] , data2)
colnames(data2)[1] <- "response"

#--------------------------------------------------------------
# Variance Inflation Factor (VIF)
#--------------------------------------------------------------
y <- data2[,1]
cov <- data2[,-1]
rand.vars <- cov
lm.dat<-data.frame(y,rand.vars)
form.in<-paste('y ~',paste(names(lm.dat)[-1],collapse='+'))
mod1<-lm(form.in,data=lm.dat)
summary(mod1)
vif_func(in_frame=rand.vars,thresh=3,trace=T)

sspp <- paste(as.character(unique(data[data$GENUS != -1, "GENUS"])), as.character(unique(data[data$SPECIES != -1, "SPECIES"])), sep="")
GSA <- unique(data$GSA)

main_sum <- paste(sspp,"_GSA",GSA,"_(",dependent,")_","_","_",depth[1],"-",depth[2],"_", sep="")

cat("-- Variance Inflation Factor --",file=paste(wd,"/output_GAM/",main_sum,"_VIF.txt", sep=""),sep="\n",append=F)
out1 <- capture.output(vif_func(in_frame=rand.vars,thresh=3,trace=T))
cat(out1,file=paste(wd,"/output_GAM/",main_sum,"_VIF.txt", sep=""),sep="\n",append=TRUE)


#--------------------------------------------------------------
# Correlation matrix
#--------------------------------------------------------------
print(rcorr(as.matrix(data2[, -1])))

cat("-- Correlation matrix --",file=paste(wd,"/output_GAM/",main_sum,"_Correlation_Matrix.txt", sep=""),sep="\n",append=F)
out1 <- capture.output(rcorr(as.matrix(data2[, -1])))
cat(out1,file=paste(wd,"/output_GAM/",main_sum,"_Correlation_Matrix.txt", sep=""),sep="\n",append=TRUE)

#--------------------------------------------------------------
# summary of the data frame content
#--------------------------------------------------------------
summary(data)

########################################################################
GSA <- unique(data$GSA)

dir_output <- paste(wd,"/output_GAM/", sep="")
if (dir.exists(dir_output)){
  cat("\nThe 'output_GAM' folder was already created")
} else {
  dir.create(file.path(dir_output), showWarnings = FALSE)
  cat("\nThe 'output_GAM' folder is now created ")
}
